%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [Diameter, Center_Point] = Get_2D_Hole_Parameters(Node_list, Axis_Point_1, Axis_Point_2)

% Несовпадение координат Axis_Point_1 и Axis_Point_2 должно проверяться вне данной функции до ее вызова

global DB_NODES;
global AT_NODES;

if (size(Axis_Point_1,1) == 3)
	Point_A = Axis_Point_1;
else
    Point_A = DB_NODES{AT_NODES(Axis_Point_1)}.Location;
end

if (size(Axis_Point_2,1) == 3)
	Point_B = Axis_Point_2;
else
    Point_B = DB_NODES{AT_NODES(Axis_Point_2)}.Location;
end

L = zeros(size(Node_list,1),1);
Distance = zeros(size(Node_list,1),1);

for i=1:size(Node_list,1)
    
    L(i) = dot(DB_NODES{AT_NODES(Node_list(i))}.Location - Point_A, Point_B - Point_A) / dot(Point_B - Point_A, Point_B - Point_A);
        
    Distance(i) = Get_Point_Line_Distance(Node_list(i), Point_A, Point_B);
    
end

L_min = min(L);
L_max = max(L);
L_mid = (L_min + L_max)/2;

C_mid = Point_A + (Point_B - Point_A)*L_mid;

Diameter = mean(Distance)*2;
Center_Point = C_mid;
